*! version 1.1.8  12feb2008  by Marc Muendler  muendler@ucsd.edu

local tlogyr = substr("${tlogyear}",3,2)
local selyr = substr("${selyear}",3,2)

tempfile iso3buba concnace cntrgrpbem unoconc

use "$root/conc/fdi-iso-country", clear
rename buba country
keep iso3code country 
sort country
compress
save `iso3buba'

use "$root/conc/sector-conc-nace", clear
sort nace11_code
compress
save `concnace'

use "$root/conc/cntry2bemgrp", clear
rename bubakey country
sort country
compress
save `cntrgrpbem'

insheet using "$root/conc/unido-industries.csv", clear
* from http://www.unido.org/doc/3531 on 3/10/2006, manually concorded with NACE 1.1 using http://unstats.un.org/unsd/cr/registry/regcs.asp?Cl=8&Lg=1&Co=3825
keep code nace11
duplicates drop
rename code isic3
sort isic3
compress
save `unoconc'

use "$root/wages/unido-wages-defl-1996-2001", clear
qui summ year
if `r(max)' >= ${selyear} & ${selyear} >= `r(min)' {
  keep if year==${selyear}
  }
if ${selyear} < `r(min)' {
  keep if year==`r(min)'
  replace year = ${selyear}
  }
if ${selyear} > `r(max)' {
  keep if year==`r(max)'
  replace year = ${selyear}
  }
rename buba country
rename mwage_ppp cntr_wage  /* country median wage (median across manufacturing industries by country, ppp adjusted) */
keep country year cntr_wage
duplicates drop
sort country year
compress
save ${uno`selyr'}

use "$root/wages/unido-wages-defl-1996-2001", clear
qui summ year
if `r(max)' >= ${tlogyear} {
  keep if year==${tlogyear}
  }
else {
  keep if year==`r(max)'
  replace year = ${tlogyear}
  }
rename buba country
rename mwage_ppp cntr_wage  /* country median wage (median across manufacturing industries by country, ppp adjusted) */
keep country year cntr_wage
duplicates drop
sort country year
compress
save ${uno`tlogyr'}

use "$root/wages/unido-wages-defl-1996-2001", clear
qui summ year
if `r(max)' >= ${selyear} & ${selyear} >= `r(min)' {
  keep if year==${selyear}
  }
if ${selyear} < `r(min)' {
  keep if year==`r(min)'
  replace year = ${selyear}
  }
if ${selyear} > `r(max)' {
  keep if year==`r(max)'
  replace year = ${selyear}
  }
rename buba country
rename mwage_ppp cntr_wage
keep if country==0  /* Germany */
rename cntr_wage cntr_wage_par
label var cntr_wage_par "Ger `lbl'"
keep year cntr_wage
duplicates drop
sort year
save ${homuno`selyr'}

use "$root/wages/unido-wages-defl-1996-2001", clear
qui summ year
if `r(max)' >= ${tlogyear} {
  keep if year==${tlogyear}
  }
else {
  keep if year==`r(max)'
  replace year = ${tlogyear}
  }
rename buba country
rename mwage_ppp cntr_wage
keep if country==0  /* Germany */
rename cntr_wage cntr_wage_par
label var cntr_wage_par "Ger `lbl'"
keep year cntr_wage
duplicates drop
sort year
save ${homuno`tlogyr'}

use "$root/wages/unido-wages-defl-1996-2001", clear
qui summ year
if `r(min)' > ${selyear} {
  replace year = ${selyear} if year==`r(min)'
  }
if `r(max)' < ${selyear} {
  replace year = ${selyear} if year==`r(max)'
  }
if `r(max)' < ${tlogyear} {
  replace year = ${tlogyear} if year==`r(max)'
  }
keep if year==${tlogyear} | year==${selyear}
keep if buba==0  /* Germany */
keep isic2 year wage_lcu
rename isic2 isic3
sort isic3
joinby isic3 using `unoconc', unmatched(master) _merge(_merge)
drop isic3 _m
collapse (median) wage_lcu, by(year nace11) fast
order nace11 year wage_lcu
rename nace11 nace1
rename wage_lcu mhomwage
sort nace1 year
compress
save ${homsecwag}

* alternative sector wages
* use "$root/wages/destatis-gearn-defl", clear /* home wage at NACE 1.1 two-digit level */
* keep if year==${tlogyear}
* keep nace11 year agearn_med
* rename nace11 nace1
* rename agearn_med mhomwage
* sort nace1 year
* compress
* save ${homsecwag}

use "$root/wages/swewages", clear
rename bubakey country
rename wage_eur lag_cntr_wage
label var lag_cntr_wage "Lag Swedish MNE wage"
gen int year = $year
sort country year
compress
save ${swe98}

use "$root/wages/swewages", clear
rename bubakey country
keep if country==0  /* Germany */
rename wage_eur lag_cntr_wage_par
label var lag_cntr_wage_par "Lag Ger Swedish MNE wage"
gen int year = $year
sort year
compress
save ${homswe98}
