*! version 1.1.3  02may2005  by Marc Muendler  muendler@ucsd.edu

tempfile iso3buba concnace cntrgrpbem

use "$root/conc/fdi-iso-country", clear
rename buba country
keep iso3code country 
sort country
compress
save `iso3buba'

use "$root/conc/sector-conc-nace", clear
sort nace11_code
compress
save `concnace'

use "$root/conc/cntry2bemgrp", clear
rename bubakey country
sort country
compress
save `cntrgrpbem'

use "$root/wages/owwdata-country-1996", clear
rename cntr_med_wage cntr_wage
keep if year==1996
sort country year
drop occ_obs_* 
compress
save ${oww96}

use "$root/wages/owwdata-country-1999", clear
rename cntr_med_wage cntr_wage
keep if year==1999
sort country year
drop occ_obs_* 
compress
save ${oww99}
replace year=2000 if year==1999
foreach var of varlist cntr_wage wage_oww_30 wage_oww_40 wage_oww_50 wage_oww_61 wage_oww_62 {
  local lbl : variable label `var'
  local lbl = subinstr("`lbl'",".","",.)
  rename `var' lg_`var'
  label var lg_`var' "Lag `lbl'"
  }
sort country year
compress
save ${oww00}

use "$root/wages/owwdata-country-1996", clear
rename cntr_med_wage cntr_wage
keep if year==1996
keep if country==0  /* Germany */
foreach var of varlist cntr_wage wage_oww_30 wage_oww_40 wage_oww_50 wage_oww_61 wage_oww_62 {
  local lbl : variable label `var'
  local lbl = subinstr("`lbl'",".","",.)
  rename `var' `var'_par
  label var `var'_par "Ger `lbl'"
  }
drop occ_obs_* country
sort year
save ${homoww96}

use "$root/wages/owwdata-country-1999", clear
rename cntr_med_wage cntr_wage
keep if year==1999
keep if country==0  /* Germany */
foreach var of varlist cntr_wage wage_oww_30 wage_oww_40 wage_oww_50 wage_oww_61 wage_oww_62 {
  local lbl : variable label `var'
  local lbl = subinstr("`lbl'",".","",.)
  rename `var' `var'_par
  label var `var'_par "Ger `lbl'"
  }
drop occ_obs_* country
sort year
save ${homoww99}
replace year=2000 if year==1999
foreach var of varlist cntr_wage wage_oww_30 wage_oww_40 wage_oww_50 wage_oww_61 wage_oww_62 {
  local lbl : variable label `var'
  local lbl = subinstr("`lbl'","per country","",.)
  local lbl = subinstr("`lbl'","Median","Med",.)
  local lbl = subinstr("`lbl'","annual","ann'l",.)
  rename `var' lg_`var'
  label var lg_`var' "Lag `lbl'"
  }
sort year
compress
save ${homoww00}

insheet using "$root/wages/gearn-defl.csv", comma clear
keep mgearn_all_cpi nace11_parent year
rename mgearn_all_cpi mhomwage
keep if year==2000 | year==1999
rename nace11_parent nace11_code
sort nace11_code 
merge nace11_code using `concnace', nokeep
tab _merge
keep if _merge==3
drop _merge nace11_code
sort buba_code
merge buba_code using "$root/conc/sector-conc-bem", nokeep
tab _merge
keep if _merge==3
drop _merge buba_code
rename sec_bem sec1_bem
sort year sec1_bem
collapse (mean) mhomwage, by(year sec1_bem)
keep if year==1999 | year==2000
sort sec1_bem year
compress
save ${homsecwag}

use "$root/wages/swewages", clear
rename bubakey country
rename wage_eur lg_cntr_wage
label var lg_cntr_wage "Lag Swedish MNE wage"
gen int year = $year
sort country year
compress
save ${swe98}

use "$root/wages/swewages", clear
rename bubakey country
keep if country==0  /* Germany */
rename wage_eur lg_cntr_wage_par
label var lg_cntr_wage_par "Lag Ger Swedish MNE wage"
gen int year = $year
sort year
compress
save ${homswe98}
