*! version 1.1.2  03mar2006  by Marc Muendler  muendler@ucsd.edu
*! version 2.0.3  28jun2009  by Marc Muendler  muendler@ucsd.edu

*----------------------following code identical to tab-estmat-selct-cf-nonparam.do--------------------------------
*-----substitute: /v6npfs for /v6np-------------------------------------------------------------------------------

/* Regional wages are supposed to be first (5) regressors in SUR equations */

* Main difference to tab-estmat-selct-cf.do: dropmiss command for eigenvalue bootstraps

translator set gph2eps logo off
translator set gph2ps  logo off
translator set gph2prn logo off

version 8
cd "$rootslct"
clear
set more off
set matsize 400
adopath + "$root/%stata/ado"

local waglvl "$waglvl"
local wagabr = subinstr("`waglvl'","wage","",.)
local wagabr = subinstr("`wagabr'","frm","",.)

capture mkdir "$rootslct/graphs"
capture mkdir "$rootslct/graphs/v6npfs"
capture mkdir "$rootslct/graphs/v6npfs/pt$par-af$aff-cf-poly2"

capture program drop dropmiss
program define dropmiss
  syntax [varlist]
  local i 1
  foreach var of varlist `varlist' {
    if `i'==1  local dropstr "`var'==."
    else       local dropstr "`dropstr' & `var'==."
    local i = `i' + 1
    }
  drop if `dropstr'
end


/* SIXTH DRAFT (v6) */

* Load variable names and save for est2tex
est2extlbl, addto(selreg_txt) intex($rootdo/%stata/rowlbl-fdiselct) p(tex/v6npfs/pt$par-af$aff-$waglvl-cf-poly2) replace
foreach mat in dprobit_apx1 dprobit_apx2 dprobit_apx3 probit_txt probit_apx1 probit_apx2 probit_apx3 sunkcost translog1 intelast1 extelast1 totelast1 intmori1 extmori1 totmori1 compelast1 compmori1 {
  est2extlbl, addto(`mat') retain p(tex/v6npfs/pt$par-af$aff-$waglvl-cf-poly2) replace
  }
clear


* SELECTION REGRESSIONS

local probit = "selreg"
 local addi ""
 local types "b se e"
 if "`probit'"=="selreg" {
   local addi "" /* alternatively: local addi "" */
   local types "`types' r"
   }
 foreach reg in $regagg {
  local r2dg = substr("`reg'",1,2)
  foreach type in `types' {
    drop _all
    use "estmat/v6npfs/pt$par-af$aff-$waglvl-cf-poly2/byreg/`probit'`r2dg'_`type'", clear
    foreach var in `r2dg'4i `r2dg'4 `r2dg'3i `r2dg'3 `r2dg'2i `r2dg'2 `r2dg'1i `r2dg'1 `r2dg'0i `r2dg'0 {
      qui replace `var' = `var'*1000 if substr(_rowname,1,2)=="w_"
      }
    save "c:/temp/`probit'`r2dg'_`type'", replace
    drop _all
    matload `probit'`r2dg'_`type', p(c:/temp) over missing(.)
    erase "c:/temp/`probit'`r2dg'_`type'.dta"
    matload `probit'`r2dg'_`type', p(estmat/v6npfs/pt$par-af$aff-$waglvl-cf-poly2/byreg) over missing(.)
    tempname chk
    capture local `chk' = colsof(`probit'_`type')
    if _rc~=0 { 
      mat rename `probit'`r2dg'_`type' `probit'_`type'
      }
    else {
      mat `probit'_`type' = `probit'_`type' , `probit'`r2dg'_`type'
      }
    capture mat drop `probit'`r2dg'_`type'
    }
  }

* prepare probit presence results
foreach type in `types' {
    mat `probit'_txt_`type' = `probit'_`type'
    matkeep `probit'_txt_`type', matrix(`probit'_txt_`type') ifc(WE${usexvar}`addi' OI${usexvar}`addi' CE${usexvar}`addi' DE${usexvar}`addi')
    }
foreach type in `types' {
  local othrreg = subinstr("0 1 2 3 4","${usexvar}","",.)
  tokenize `othrreg'
  forvalues i = 1/3 { /* Up to 4 further matrices */
    mat `probit'_apx`i'_`type' = `probit'_`type'
    matkeep `probit'_apx`i'_`type', matrix(`probit'_apx`i'_`type') ifc(WE``i''`addi' OI``i''`addi' CE``i''`addi' DE``i''`addi')
    }
  mat drop `probit'_`type'
  }
est2tex `probit'_txt , replace dropall preserve mark(starse) path(tex/v6npfs/pt$par-af$aff-$waglvl-cf-poly2) fancy levels(90 95 99)
est2tex `probit'_apx1, replace dropall preserve mark(starse) path(tex/v6npfs/pt$par-af$aff-$waglvl-cf-poly2) fancy levels(90 95 99)
est2tex `probit'_apx2, replace dropall preserve mark(starse) path(tex/v6npfs/pt$par-af$aff-$waglvl-cf-poly2) fancy levels(90 95 99)
est2tex `probit'_apx3, replace dropall preserve mark(starse) path(tex/v6npfs/pt$par-af$aff-$waglvl-cf-poly2) fancy levels(90 95 99)
* est2tex `probit'_apx4, replace dropall preserve mark(starse) path(tex/v6npfs/pt$par-af$aff-$waglvl-cf-poly2) fancy levels(90 95 99)


* TRANSLOG REGRESSIONS

foreach usemissg in $howmany {
  foreach type in b se e {
    tempname trlg`usemissg'`waglvl'_`type'
    * local trlg`usemissg'`waglvl'_`type' "trlg`usemissg'`waglvl'_`type'"
    drop _all
    matload translog`usemissg'_`type', p(estmat/v6npfs/pt$par-af$aff-$waglvl-cf-poly2/translog`usemissg') over missing(.)
    mat rename translog`usemissg'_`type' `trlg`usemissg'`waglvl'_`type''
    }
  local colmax = colsof(`trlg`usemissg'`waglvl'_e')
  local rowmax = rowsof(`trlg`usemissg'`waglvl'_e')
  tempname trlg`usemissg'`waglvl'_r
  * local trlg`usemissg'`waglvl'_r "trlg`usemissg'`waglvl'_r"
  mat `trlg`usemissg'`waglvl'_r' = `trlg`usemissg'`waglvl'_e'[1..6,1..`colmax']  /* Overall reports */
  mat `trlg`usemissg'`waglvl'_e' = `trlg`usemissg'`waglvl'_e'[7..`rowmax',1..`colmax']  /* Equation-specific reports */
  }

foreach usemissg in $howmany {
local col = 1  /* First column from trlg`usemissg'`waglvl' output (only one exists) */

* Translog regression estimates
foreach type in b se e {
    local rowmax = rowsof(`trlg`usemissg'`waglvl'_`type'')/4
    local colnames : roweq `trlg`usemissg'`waglvl'_`type''
    local colnames : list uniq colnames
    mat translog`usemissg'_`type' = `trlg`usemissg'`waglvl'_`type''[1..`rowmax',`col'] , `trlg`usemissg'`waglvl'_`type''[`rowmax'+1..`rowmax'*2,`col'] , `trlg`usemissg'`waglvl'_`type''[`rowmax'*2+1..`rowmax'*3,`col'] , `trlg`usemissg'`waglvl'_`type''[`rowmax'*3+1..`rowmax'*4,`col']
    local rownames : rownames translog`usemissg'_`type'
    tokenize `rownames'
    forvalues row = 1/`rowmax' {
        matname translog`usemissg'_`type' :``row'', rows(`row') explicit
        }
    if "`type'"~="e" {
        matname translog`usemissg'_`type' `colnames', columns(1..4) explicit
        }
    else {
        local colnames : colnames translog`usemissg'_b
        matname translog`usemissg'_`type' `colnames', columns(1..4) explicit
        matname translog`usemissg'_`type' e(r2) e(chi2) e(p), rows(1..3) explicit
        }
    }
local rowmax = rowsof(`trlg`usemissg'`waglvl'_r')
mat translog`usemissg'_r = `trlg`usemissg'`waglvl'_r'[1..`rowmax',`col'] , J(`rowmax',3,.)
est2tex translog`usemissg', replace dropall preserve mark(starse) path(tex/v6npfs/pt$par-af$aff-$waglvl-cf-poly2) fancy levels(90 95 99)
* est2tex trlg`usemissg'`waglvl', replace dropall preserve mark(starse) path(tex/v6npfs/pt$par-af$aff-$waglvl-cf-poly2) fancy levels(90 95 99)
}


* ELASTICITY MATRICES

foreach usemissg in $howmany {  /* begin `usemissg' loop */

foreach elsttyp in Int Ext Tot { /* begin `base' loop */
local elstld = lower("`elsttyp'")

* CROSS-PRICE elasticity matrices
local dim = 5
matload `elstld'elast`usemissg'_b, p(estmat/v6npfs/pt$par-af$aff-$waglvl-cf-poly2/translog`usemissg') over missing(.)
matload tmat`usemissg'_tbl, p(estmat/v6npfs/pt$par-af$aff-$waglvl-cf-poly2/translog`usemissg') over missing(.)
matload zetamat`usemissg'_tbl, p(estmat/v6npfs/pt$par-af$aff-$waglvl-cf-poly2/translog`usemissg') over missing(.)
matload semat`usemissg'_tbl, p(estmat/v6npfs/pt$par-af$aff-$waglvl-cf-poly2/translog`usemissg') over missing(.)

* Analytic standard errors for joint margins, CROSS-PRICE elasticities, NEW method
* r1=0 (sample correlation between wage coefficients and product of region-mean cost shares) as Anderson and Thursby (1986) suggest
* r2 (estimated correlation between numerator and denominator of cross-price elasticity, conditional on r1=0) contained in zetamat`usemissg'_tbl
* Note that semat`usemissg'_tbl not symmetric after Heckman correction
if "`elsttyp'"=="Int" {
tempname upsilonsq
foreach mat in `elstld'elast`usemissg'_se `upsilonsq' {
  matrix `mat' = J(`dim',`dim',0)
  local rownames : rowfullname `elstld'elast`usemissg'_b
  matname `mat' `rownames', rows(1..`dim') explicit
  local colnames : colfullname `elstld'elast`usemissg'_b
  matname `mat' `colnames', columns(1..`dim') explicit
  }
* tmat`usemissg'_tbl contains row 1: theta; row 2: sd_theta; row 3: N.
forvalues r = 1/`dim' {
  forvalues m = 1/`dim' {
   matrix `upsilonsq'[`r',`m'] = ( tmat`usemissg'_tbl[1,`r']^2 * tmat`usemissg'_tbl[2,`m']^2 + tmat`usemissg'_tbl[1,`m']^2 * tmat`usemissg'_tbl[2,`r']^2 + 2 * tmat`usemissg'_tbl[1,`r'] * tmat`usemissg'_tbl[1,`m'] * tmat`usemissg'_tbl[2,`r'] * tmat`usemissg'_tbl[2,`m'] * zetamat`usemissg'_tbl[`r',`m'] + (1 + zetamat`usemissg'_tbl[`r',`m']) * tmat`usemissg'_tbl[2,`r']^2 * tmat`usemissg'_tbl[2,`m']^2 ) / tmat`usemissg'_tbl[3,`r'] 
   matrix `elstld'elast`usemissg'_se[`r',`m'] = tmat`usemissg'_tbl[1,`r']^(-1) * sqrt( tmat`usemissg'_tbl[3,`r']^(-1) * `elstld'elast`usemissg'_b[`r',`m']^2 * tmat`usemissg'_tbl[2,`r']^2 - 2 * zetamat`usemissg'_tbl[`r',`m'] * `elstld'elast`usemissg'_b[`r',`m'] * tmat`usemissg'_tbl[2,`r'] * sqrt( semat`usemissg'_tbl[`r',`m']^2 + `upsilonsq'[`r',`m'] ) / sqrt(tmat`usemissg'_tbl[3,`r']) + semat`usemissg'_tbl[`r',`m']^2 + `upsilonsq'[`r',`m'] )
   }
 }
capture mat drop `elstld'elast`usemissg'_se1
mat rename `elstld'elast`usemissg'_se `elstld'elast`usemissg'_se1
}

* Bootstrapped standard errors for CROSS-PRICE elasticity matrix
mat `elstld'elast`usemissg'_e = tmat`usemissg'_tbl[3,1..`dim'] /* Observation number */
use "estmat/v6npfs/pt$par-af$aff-$waglvl-cf-poly2/translog`usemissg'/elast`usemissg'_bstrap", clear
keep b_`elsttyp'_l*
matrix `elstld'elast`usemissg'_b4 = J(`dim',`dim',.)
matrix `elstld'elast`usemissg'_se4 = J(`dim',`dim',.)
local rownames : rowfullname `elstld'elast`usemissg'_b
matname `elstld'elast`usemissg'_b4 `rownames', rows(1..`dim') explicit
matname `elstld'elast`usemissg'_se4 `rownames', rows(1..`dim') explicit
local colnames : colfullname `elstld'elast`usemissg'_b
matname `elstld'elast`usemissg'_b4 `colnames', columns(1..`dim') explicit
matname `elstld'elast`usemissg'_se4 `colnames', columns(1..`dim') explicit
local cols = subinstr("`colnames'","s","",`dim')
local rows = subinstr("`rownames'","s","",`dim')
local ordrvar ""
local r 0
foreach rownm in `rows' {
  local r = `r' + 1
  local m 0
  foreach colnm in `cols' {
    local m = `m' + 1
    tempname bstrp_b bstrp_se
    local ordrvar "`ordrvar' b_`elsttyp'_l`rownm'_w`colnm'"
    capture confirm variable b_`elsttyp'_l`rownm'_w`colnm'
    if _rc~=111 {
      qui bstat b_`elsttyp'_l`rownm'_w`colnm'
      mat `bstrp_b'  = e(b)
      mat `bstrp_se' = e(se)
      }
    else {
      mat `bstrp_b' = .
      mat `bstrp_se' = .
      }
    mat `elstld'elast`usemissg'_b4[`r',`m'] = `bstrp_b'[1,1]
    mat `elstld'elast`usemissg'_se4[`r',`m'] = `bstrp_se'[1,1]
    }
  }
tempname chkmatb chkmatse
mat `chkmatb' = `elstld'elast`usemissg'_b4 - `elstld'elast`usemissg'_b
if abs(trace(`chkmatb')) + abs(det(`chkmatb')) > 1.e-05 & abs(trace(`chkmatb')) + abs(det(`chkmatb')) ~=. {
  disp as err "Bootstrapped coefficients and coefficient estimates differ."
  STOP
  }
mat drop `elstld'elast`usemissg'_b4 
* alternative calculation of standard errors
* order `ordrvar'
* qui count
* local totreps = `r(N)'
* tempname VCE varvec
* matrix accum `VCE' = *, deviations noconstant
* drop _all
* matrix `VCE' = `VCE'/(`totreps'-1)
* matrix `varvec' = vecdiag(`VCE')'
* local rownmb = rowsof(`varvec')
* mat `elstld'elast`usemissg'_se5=J(`dim',`dim',.)
* local estnams : rownames `varvec'
* tokenize `estnams'
* forvalues i = 1/`dim' {
*   forvalues j = 1/`dim' {
*     local row = (`i'-1)*`dim' + `j'
*     matrix `elstld'elast`usemissg'_se5[`i',`j']=sqrt(`varvec'[`row',1])
*     local rowlbl = "s" + substr("``row''",-6,2)
*     local collbl = "s" + substr("``row''",-2,2)
*     matname `elstld'elast`usemissg'_se5 `rowlbl', rows(`i') explicit
*     matname `elstld'elast`usemissg'_se5 `collbl', columns(`j') explicit
*     }
*   }
* mat `chkmatse' = `elstld'elast`usemissg'_se5 - `elstld'elast`usemissg'_se4
* if abs(trace(`chkmatse')) + abs(det(`chkmatse')) > 1.e-05 {
*   disp as err "Stata reported standard errors and bootstrapped standard errors differ differ."
*   STOP
*   }
* mat drop `elstld'elast`usemissg'_se5
* end alternative calculation of standard errors
local colnames : colnames `elstld'elast`usemissg'_b
local colnames = subinstr("`colnames'","s","mWage",.)
local rownames : rownames `elstld'elast`usemissg'_b
local rownames = subinstr("`rownames'","s","rLDem",.)
local multse "4"
if "`elsttyp'"=="Int" {
  matname `elstld'elast`usemissg'_se1 `colnames', columns(1..`dim') explicit
  local multse "1 4"
  }
foreach type in b se4 {
  matname `elstld'elast`usemissg'_`type' `colnames', columns(1..`dim') explicit
  }
matname `elstld'elast`usemissg'_e e(theta_N), rows(1) explicit
matname `elstld'elast`usemissg'_b `rownames', rows(1..`dim') explicit
est2tex `elstld'elast`usemissg', replace dropall preserve multse(`multse') mark(starse 4) path(tex/v6npfs/pt$par-af$aff-$waglvl-cf-poly2) fancy levels(90 95 99)

* MORISHIMA elasticity matrices
mat `elstld'mori`usemissg'_b = J(`dim',`dim',.)
forvalues r = 1/`dim' {  /* Fill all entries */
  forvalues m = 1/`dim' {
    mat `elstld'mori`usemissg'_b[`r',`m'] = `elstld'elast`usemissg'_b[`m',`r'] - `elstld'elast`usemissg'_b[`r',`r']
    }
  }
local colnames : colfullname `elstld'elast`usemissg'_b
local colnew = subinstr("`colnames'","mWage","relWage",`dim')
matname `elstld'mori`usemissg'_b `colnew', columns(1..`dim') explicit
local rownames : rowfullname `elstld'elast`usemissg'_b
local rownew = subinstr("`rownames'","rLDem","relLDem",`dim')
matname `elstld'mori`usemissg'_b `rownew', rows(1..`dim') explicit

* Bootstrapped standard errors for MORISHIMA matrix
mat `elstld'mori`usemissg'_e = tmat`usemissg'_tbl[3,1..`dim'] /* Observation number */
use "estmat/v6npfs/pt$par-af$aff-$waglvl-cf-poly2/translog`usemissg'/elast`usemissg'_bstrap", clear
keep b_`elsttyp'_l*
matrix `elstld'mori`usemissg'_b4 = J(`dim',`dim',.)
local rownames : rowfullname `elstld'elast`usemissg'_b
matname `elstld'mori`usemissg'_b4 `rownames', rows(1..`dim') explicit
local colnames : colfullname `elstld'elast`usemissg'_b
matname `elstld'mori`usemissg'_b4 `colnames', columns(1..`dim') explicit
local cols = subinstr("`colnames'","mWage","",`dim')
local rows = subinstr("`rownames'","rLDem","",`dim')
local ordrvar ""
tempname prelim
mat `prelim' = `elstld'mori`usemissg'_b4
local r 0
foreach rownm in `rows' {
  local r = `r' + 1
  local m 0
  foreach colnm in `cols' {
    local m = `m' + 1
    tempname bstrp_b
    local ordrvar "`ordrvar' mori_`elsttyp'_l`rownm'_w`colnm'"
    capture confirm variable b_`elsttyp'_l`rownm'_w`colnm'
    if _rc~=111 {
      qui bstat b_`elsttyp'_l`rownm'_w`colnm'
      mat `bstrp_b'  = e(b)
      }
    else {
      mat `bstrp_b'  = .
      }
    mat `prelim'[`r',`m'] = `bstrp_b'[1,1]
    }
  }
local r 0
foreach rownm in `rows' {
  local r = `r' + 1
  local m 0
  foreach colnm in `cols' {
    local m = `m' + 1
    mat `elstld'mori`usemissg'_b4[`r',`m'] = `prelim'[`m',`r'] - `prelim'[`r',`r']
    capture confirm variable b_`elsttyp'_l`colnm'_w`rownm' b_`elsttyp'_l`rownm'_w`rownm'
    if _rc~=111 {
      gen double mori_`elsttyp'_l`rownm'_w`colnm' = b_`elsttyp'_l`colnm'_w`rownm' - b_`elsttyp'_l`rownm'_w`rownm'
      }
    else {
      gen byte mori_`elsttyp'_l`rownm'_w`colnm' = 0
      }
    }
  }
tempname chkmatb
mat `chkmatb' = `elstld'mori`usemissg'_b4 - `elstld'mori`usemissg'_b
if abs(trace(`chkmatb')) + abs(det(`chkmatb')) > 1.e-05 & abs(trace(`chkmatb')) + abs(det(`chkmatb')) ~=. {
  disp as err "Bootstrapped coefficients and coefficient estimates differ."
  STOP
  }
mat drop `elstld'mori`usemissg'_b4
drop b_`elsttyp'_l*
* calculation of standard errors (code checked above for cross-price elasticities)
order `ordrvar'
qui count
local totreps = `r(N)'
tempname VCE varvec
matrix accum `VCE' = *, deviations noconstant
drop _all
matrix `VCE' = `VCE'/(`totreps'-1)
matrix `varvec' = vecdiag(`VCE')'
local rownmb = rowsof(`varvec')
mat `elstld'mori`usemissg'_se4=J(`dim',`dim',.)
local estnams : rownames `varvec'
tokenize `estnams'
forvalues i = 1/`dim' {
  forvalues j = 1/`dim' {
    local row = (`i'-1)*`dim' + `j'
    matrix `elstld'mori`usemissg'_se4[`i',`j']=sqrt(`varvec'[`row',1])
    local rowlbl = "s" + substr("``row''",-6,2)
    local collbl = "s" + substr("``row''",-2,2)
    matname `elstld'mori`usemissg'_se4 `rowlbl', rows(`i') explicit
    matname `elstld'mori`usemissg'_se4 `collbl', columns(`j') explicit
    }
  }
local colnames : colnames `elstld'mori`usemissg'_b
local colnames = subinstr("`colnames'","s","mWage",.)
local rownames : rownames `elstld'mori`usemissg'_b
local rownames = subinstr("`rownames'","s","rLDem",.)
foreach type in b se4 {
  matname `elstld'mori`usemissg'_`type' `colnames', columns(1..`dim') explicit
  }
matname `elstld'mori`usemissg'_e e(theta_N), rows(1) explicit
matname `elstld'mori`usemissg'_b `rownames', rows(1..`dim') explicit
est2tex `elstld'mori`usemissg', replace dropall preserve multse(4) mark(starse 4) path(tex/v6npfs/pt$par-af$aff-$waglvl-cf-poly2) fancy levels(90 95 99)


* ALLEN-UZAWA elasticity matrix (and its eigenvalues at intensive margin)
tempname evec aumat
mat `aumat' = `elstld'elast`usemissg'_b
forvalues r = 1/`dim' {  /* Fill all entries */
  forvalues m = 1/`dim' {
    mat `aumat'[`r',`m'] = `aumat'[`r',`m'] / tmat`usemissg'_tbl[1,`m']
    }
  }
if "`elsttyp'"=="Int" {
matrix symeigen `evec' eigval`usemissg'_b = `aumat'
matname eigval`usemissg'_b eigenvalue, rows(1) explicit
mat drop `evec' tmat`usemissg'_tbl
}

* Bootstrapped standard errors for ALLEN-UZAWA EIGENVALUES (at intensive margin only)
if "`elsttyp'"=="Int" {
tempfile eivalbstrp
use "estmat/v6npfs/pt$par-af$aff-$waglvl-cf-poly2/translog`usemissg'/elast`usemissg'_bstrap", clear
dropmiss *
qui count
local opreps = `r(N)'
forvalues i = 1/`dim' {
  gen eigval`i' = .
  }
* calculate eigenvalues per (operational) bootstrap repetition
tempname eigval
forvalues rep = 1/`opreps' {
  mat `aumat' = J(`dim',`dim',.)
  local r 0
  foreach regr in HO WE OI CE DE {
    local r = `r' + 1
    local m 0
    foreach regm in HO WE OI CE DE {
      local m = `m' + 1
      mat `aumat'[`r',`m'] = b_`elsttyp'_l`regr'_w`regm'[`rep'] / b_`elsttyp'_s`regm'mean[`rep']
    }
  }
  matrix symeigen `evec' `eigval' = `aumat'
  matname `eigval' eigenvalue, rows(1) explicit
  mat drop `evec'
  forvalues i = 1/`dim' {
    qui replace eigval`i' = `eigval'[1,`i'] in `rep'
    }
 } /* close loop over bootstrap repetitions (observations) */
save `eivalbstrp'
keep eigval*
matrix accum `VCE' = *, deviations noconstant
drop _all
matrix `VCE' = `VCE'/(`totreps'-1)
* matrix list `VCE'
matrix `varvec' = vecdiag(`VCE')'
local rownmb = rowsof(`varvec')
mat eigval`usemissg'_se4=J(1,`dim',.)
local estnams : rownames `varvec'
tokenize `estnams'
forvalues j = 1/`dim' {
  matrix eigval`usemissg'_se4[1,`j']=sqrt(`varvec'[`j',1])
  local collbl = "``j''"
  matname eigval`usemissg'_b `collbl', columns(`j') explicit
  matname eigval`usemissg'_se4 `collbl', columns(`j') explicit
  }
matname eigval`usemissg'_se4 eigenvalue, rows(1) explicit
local colnames : colnames eigval`usemissg'_b
mat eigval`usemissg'_e = J(1,`dim',`totreps')
matname eigval`usemissg'_e bstrp_reps, rows(1) explicit
foreach type in b se4 e {
    matname eigval`usemissg'_`type' `colnames', columns(1..`dim') explicit
    }
est2tex eigval`usemissg', replace dropall preserve multse(4) mark(starse 4) path(tex/v6npfs/pt$par-af$aff-$waglvl-cf-poly2) fancy levels(90 95 99)


* PLAUSIBILITY EVALUATION OF TRANSLOG ESTIMATION
matload negxhatcnt`usemissg', p(estmat/v6npfs/pt$par-af$aff-$waglvl-cf-poly2/translog`usemissg') over missing(.)
mat negxhatcnt`usemissg' = J(2,1,.) , negxhatcnt`usemissg'
matname negxhatcnt`usemissg' sHO, columns(1) explicit
matname negxhatcnt`usemissg' r(N_neg_theta_pred) r(N), rows(1..2) explicit
mat possharcnt`usemissg'_tbl = negxhatcnt`usemissg'[2,1..5] - negxhatcnt`usemissg'[1,1..5]
mat possharcnt`usemissg'_tbl = possharcnt`usemissg'_tbl \ negxhatcnt`usemissg'[2,1..5]
matname possharcnt`usemissg'_tbl r(N_pos_theta_pred) r(N), rows(1..2) explicit
mat possharcnt`usemissg'_tbl = possharcnt`usemissg'_tbl[1..2,2..5]
est2tex possharcnt`usemissg', replace dropall preserve ready path(tex/v6npfs/pt$par-af$aff-$waglvl-cf-poly2) fancy
matload elastsum`usemissg', p(estmat/v6npfs/pt$par-af$aff-$waglvl-cf-poly2/translog`usemissg') over missing(.)
mat elastsum`usemissg'_tbl = elastsum`usemissg'[1,1..5]
matname elastsum`usemissg'_tbl elast_rowsum, rows(1) explicit
est2tex elastsum`usemissg', replace dropall preserve ready path(tex/v6npfs/pt$par-af$aff-$waglvl-cf-poly2) fancy
matload negeivalcnt`usemissg', p(estmat/v6npfs/pt$par-af$aff-$waglvl-cf-poly2/translog`usemissg') over missing(.)
mat rename negeivalcnt`usemissg' negeivalcnt`usemissg'_tbl
est2tex negeivalcnt`usemissg', replace dropall preserve ready path(tex/v6npfs/pt$par-af$aff-$waglvl-cf-poly2) fancy
mat drop negxhatcnt`usemissg' possharcnt`usemissg'_tbl elastsum`usemissg'_tbl negeivalcnt`usemissg'_tbl 

* Kernel graphs of eigenvalues
use `eivalbstrp'
keep eigval*
preserve
  forvalues i = 1/5 {
    restore, preserve
    tempfile eigfile`i'
    keep eigval`i'
    rename eigval`i' eigval
    gen byte eigvalnum = `i'
    save `eigfile`i''
  }
restore
use `eigfile1', clear
forvalues i = 2/5 {
  append using `eigfile`i''
  }
kdensity eigval, nograph generate(x0 allvals)
label var x0 "Eigenvalues"
forvalues i = 1/5 {
  tempname eival`i'
  kdensity eigval if eigvalnum==`i', nograph generate(`eival`i'') at(x0)
  label var `eival`i'' "Eigenvalue `i'"
  }
drop allvals
graph7 `eival1' `eival2' `eival3' `eival4' `eival5' x0, xlab ylab connect(lllll) saving("graphs/v6npfs/pt$par-af$aff-cf-poly2/eigval`usemissg'-$waglvl-cf", replace)
translate "graphs/v6npfs/pt$par-af$aff-cf-poly2/eigval`usemissg'-$waglvl-cf.gph" "graphs/v6npfs/pt$par-af$aff-cf-poly2/eigval`usemissg'-$waglvl-cf.eps", translator(gph2eps) replace
erase "graphs/v6npfs/pt$par-af$aff-cf-poly2/eigval`usemissg'-$waglvl-cf.gph"
drop _all
}

foreach type in b se se1 se4 r e tbl {
  capture mat drop selreg_txt_`type'
  capture mat drop selreg_apx1_`type'
  capture mat drop selreg_apx2_`type'
  capture mat drop selreg_apx3_`type'
  capture mat drop translog`usemissg'_`type'
  capture mat drop elastsum`usemissg'_`type'
  capture mat drop eigval`usemissg'_`type'
  capture mat drop tfmori`elsttyp'`usemissg'`wagabr'_`type'
  capture mat drop tmat`usemissg'_`type'
  capture mat drop semat`usemissg'_`type'
  capture mat drop zetamat`usemissg'_`type'
  }
capture mat drop elastsum`usemissg'
capture mat drop `elstld'elast`usemissg'_se1
mat rename `elstld'elast`usemissg'_se4 `elstld'elast`usemissg'_se
mat rename `elstld'mori`usemissg'_se4 `elstld'mori`usemissg'_se
capture mat drop `elstld'elast`usemissg'_tbl
capture mat drop `elstld'mori`usemissg'_tbl

} /* close `base' loop */


* COMPARISON MATRICES OF ELASTICITIES

foreach mattyp in elast mori {
  foreach type in b se e {
    local `type'rows = rowsof(int`mattyp'`usemissg'_`type')
    forvalues r = 1/``type'rows' {
      mat comp`mattyp'_`type'_`r' = int`mattyp'`usemissg'_`type'[`r',1..colsof(int`mattyp'`usemissg'_`type')] \ ext`mattyp'`usemissg'_`type'[`r',1..colsof(ext`mattyp'`usemissg'_`type')]
      matrix roweq comp`mattyp'_`type'_`r' = int ext
      }
    mat comp`mattyp'`usemissg'_`type' = comp`mattyp'_`type'_1
    mat drop comp`mattyp'_`type'_1
    forvalues r = 2/``type'rows' {
      mat comp`mattyp'`usemissg'_`type' = comp`mattyp'`usemissg'_`type' \ comp`mattyp'_`type'_`r'
      mat drop comp`mattyp'_`type'_`r'
      }
    }
  est2tex comp`mattyp'`usemissg', replace dropall preserve mark(starb) path(tex/v6npfs/pt$par-af$aff-$waglvl-cf-poly2) fancy levels(90 95 99)
  }

foreach elsttyp in comp int ext tot {
  foreach type in b se se1 se4 r e tbl {
    capture mat drop `elsttyp'elast`usemissg'_`type'
    capture mat drop `elsttyp'mori`usemissg'_`type'
    }
  }

} /* close `'usemissg' loop */

*----------------------above code identical to tab-estmat-selct-cf-nonparam.do------------------------------------------

cd "$root"
