*! version 1.0.7  14nov2006  by Marc Muendler muendler@ucsd.edu

clear
set memory 400m
set matsize 400
set more off
capture log close

cd "$rootslct"

log using "logs/comp-mat-ger-cf.log", replace

capture mkdir "$rootslct/tex/desc"

mat drop _all

adopath + "$root/%stata/ado"


foreach usemissg in $howmany {


* COMPARISON MATRICES OF ELASTICITIES

foreach aff in manf {
  foreach waglvl in frmowwwage frmubswage frmunowage {
   local wage = substr("`waglvl'",4,3)
   matload intelast`usemissg'_tbl, path(tex/v6fs/pt$par-af`aff'-`waglvl'-cf) missing(.)
   mat rename intelast`usemissg'_tbl int`aff'`wage'`usemissg'_tbl
   }
 }
local tblrows : word count $reghomagg
local lstrow = `tblrows'+1

* Compare OWW and UNO wages for manufacturing affiliates
forvalues r = 1/`tblrows' {  /* keep b (1st row) and se4 (3rd row) */
  mat compmanfowwuno_tbl_`r' = intmanfoww`usemissg'_tbl[(`r'-1)*3+1,1..colsof(intmanfoww`usemissg'_tbl)] \ intmanfoww`usemissg'_tbl[`r'*3,1..colsof(intmanfoww`usemissg'_tbl)] \ intmanfuno`usemissg'_tbl[(`r'-1)*3+1,1..colsof(intmanfuno`usemissg'_tbl)] \ intmanfuno`usemissg'_tbl[`r'*3,1..colsof(intmanfuno`usemissg'_tbl)]
  matrix roweq compmanfowwuno_tbl_`r' = manfoww manfoww manfuno manfuno
  matname compmanfowwuno_tbl_`r' _se, rows(2) explicit
  matname compmanfowwuno_tbl_`r' _se, rows(4) explicit
  }
mat compmanfowwuno_tbl_`lstrow' = intmanfoww`usemissg'_tbl[`tblrows'*3+1,1..colsof(intmanfoww`usemissg'_tbl)] \ intmanfuno`usemissg'_tbl[`tblrows'*3+1,1..colsof(intmanfuno`usemissg'_tbl)]
matrix roweq compmanfowwuno_tbl_`lstrow' = manfoww manfuno
mat compmanfowwuno`usemissg'_tbl = compmanfowwuno_tbl_1
mat drop compmanfowwuno_tbl_1
forvalues r = 2/`lstrow' {
  mat compmanfowwuno`usemissg'_tbl = compmanfowwuno`usemissg'_tbl \ compmanfowwuno_tbl_`r'
  mat drop compmanfowwuno_tbl_`r'
  }
est2tex compmanfowwuno`usemissg', ready replace dropall preserve mark(starb) path(tex/v6fs) fancy levels(90 95 99)

/* Compare manufacturing and nonmanufacturing affiliates for UNO wages
forvalues r = 1/`tblrows' { /* keep b (1st row) and se4 (3rd row) */
  mat compmanfnonmfuno_tbl_`r' = intmanfuno`usemissg'_tbl[(`r'-1)*3+1,1..colsof(intmanfuno`usemissg'_tbl)] \ intmanfuno`usemissg'_tbl[`r'*3,1..colsof(intmanfuno`usemissg'_tbl)] \ intnonmfuno`usemissg'_tbl[(`r'-1)*3+1,1..colsof(intnonmfuno`usemissg'_tbl)] \ intnonmfuno`usemissg'_tbl[`r'*3,1..colsof(intnonmfuno`usemissg'_tbl)]
  matrix roweq compmanfnonmfuno_tbl_`r' = manfuno manfuno manfuno manfuno
  matname compmanfnonmfuno_tbl_`r' _se, rows(2) explicit
  matname compmanfnonmfuno_tbl_`r' _se, rows(4) explicit
  }
mat compmanfnonmfuno_tbl_`lstrow' = intmanfuno`usemissg'_tbl[`tblrows'*3+1,1..colsof(intmanfuno`usemissg'_tbl)] \ intnonmfuno`usemissg'_tbl[`tblrows'*3+1,1..colsof(intnonmfuno`usemissg'_tbl)]
matrix roweq compmanfnonmfuno_tbl_`lstrow' = manfuno manfuno
mat compmanfnonmfuno`usemissg'_tbl = compmanfnonmfuno_tbl_1
mat drop compmanfnonmfuno_tbl_1
forvalues r = 2/`lstrow' {
  mat compmanfnonmfuno`usemissg'_tbl = compmanfnonmfuno`usemissg'_tbl \ compmanfnonmfuno_tbl_`r'
  mat drop compmanfnonmfuno_tbl_`r'
  }
est2tex compmanfnonmfuno`usemissg', ready replace dropall preserve mark(starb) path(tex/v6fs) fancy levels(90 95 99)
*/

}

log close
cd "$root"
