*! version 1.4.2  15jun2009  by Marc Muendler  muendler@ucsd.edu
*! version 1.5.1  10sep2009  by Marc Muendler  muendler@ucsd.edu


/* Regional wages are supposed to be first (5) regressors in SUR equations */

translator set gph2eps logo off
translator set gph2ps  logo off
translator set gph2prn logo off

version 8
cd "$rootslct"
clear
set more off
set matsize 150
adopath + "$root/%stata/ado"

local waglvl "$waglvl"
local wagabr = subinstr("`waglvl'","wage","",.)
local wagabr = subinstr("`wagabr'","frm","",.)

capture mkdir "tex/v6fs/pt$par-af$aff-$waglvl-uncorr-selct2stp-cf"


/* SIXTH DRAFT (v6) */

* Load variable names and save for est2tex
est2extlbl, addto(intelast1) intex($rootdo/%stata/rowlbl-fdiselct) p(tex/v6fs/pt$par-af$aff-$waglvl-uncorr-selct2stp-cf) replace
foreach mat in extelast1 totelast1 uncorr1_aerrr {
  est2extlbl, addto(`mat') retain p(tex/v6fs/pt$par-af$aff-$waglvl-uncorr-selct2stp-cf) replace
  est2extlbl, addto(`mat') retain p(tex/v6fs/pt$par-af$aff-$waglvl-uncorr-selct2stp-cf) replace
  }
clear


* ELASTICITY MATRICES WITH STD ERRORS ON BIASES

local dim = 5

foreach usemissg in $howmany {  /* begin `usemissg' loop */

foreach elsttyp in Int Ext Tot { /* begin `base' loop */
local elstld = lower("`elsttyp'")

matload `elstld'elast`usemissg'_b, p(estmat/v6fs/pt$par-af$aff-$waglvl-uncorrected-cf/translog`usemissg') over missing(.) dropall
local rownames : rowfullname `elstld'elast`usemissg'_b
local colnames : colfullname `elstld'elast`usemissg'_b
mat drop `elstld'elast`usemissg'_b

use "estmat/v6fs/pt$par-af$aff-$waglvl-uncorr-selct2stp-cf/translog`usemissg'/elast`usemissg'_bstrap", clear
keep b_`elsttyp'_l*
matrix `elstld'elast`usemissg'_b4 = J(`dim',`dim',.)
matrix `elstld'elast`usemissg'_se4 = J(`dim',`dim',.)
matname `elstld'elast`usemissg'_b4 `rownames', rows(1..`dim') explicit
matname `elstld'elast`usemissg'_se4 `rownames', rows(1..`dim') explicit
matname `elstld'elast`usemissg'_b4 `colnames', columns(1..`dim') explicit
matname `elstld'elast`usemissg'_se4 `colnames', columns(1..`dim') explicit
local cols = subinstr("`colnames'","s","",`dim')
local rows = subinstr("`rownames'","s","",`dim')
local ordrvar ""
local r 0
foreach rownm in `rows' {
  local r = `r' + 1
  local m 0
  foreach colnm in `cols' {
    local m = `m' + 1
    tempname bstrp_b bstrp_se
    local ordrvar "`ordrvar' b_`elsttyp'_l`rownm'_w`colnm'"
    capture confirm variable b_`elsttyp'_l`rownm'_w`colnm'
    if _rc~=111 {
      qui bstat b_`elsttyp'_l`rownm'_w`colnm'
      mat `bstrp_b'  = e(b)
      mat `bstrp_se' = e(se)
      }
    else {
      mat `bstrp_b' = .
      mat `bstrp_se' = .
      }
    if `bstrp_b'[1,1]==-999  mat `elstld'elast`usemissg'_b4[`r',`m'] = .
    else  mat `elstld'elast`usemissg'_b4[`r',`m'] = `bstrp_b'[1,1]
    if `bstrp_se'[1,1]==-999  mat `elstld'elast`usemissg'_se4[`r',`m'] = .
    else  mat `elstld'elast`usemissg'_se4[`r',`m'] = `bstrp_se'[1,1]
    }
  }
mat rename `elstld'elast`usemissg'_b4 `elstld'elast`usemissg'_b
local colnames : colnames `elstld'elast`usemissg'_b
local colnames = subinstr("`colnames'","s","mWage",.)
local rownames : rownames `elstld'elast`usemissg'_b
local rownames = subinstr("`rownames'","s","rLDem",.)
local multse "4"
foreach type in b se4 {
  matname `elstld'elast`usemissg'_`type' `colnames', columns(1..`dim') explicit
  }
mat `elstld'elast`usemissg'_e = J(1,`dim',.)
matname `elstld'elast`usemissg'_e e(theta_N), rows(1) explicit
matname `elstld'elast`usemissg'_b `rownames', rows(1..`dim') explicit
est2tex `elstld'elast`usemissg', replace dropall preserve multse(`multse') mark(starse 4) path(tex/v6fs/pt$par-af$aff-$waglvl-uncorr-selct2stp-cf) fancy levels(90 95 99)

} /* close `base' loop */

} /* close `usemissg' loop */


* ELASTICITY MATRICES WITH INDICATOR OF STAT SIGNIFICANCE OF UNDERLYING COEFFICIENTS (BEHIND REL BIAS)

local usemissg 1

foreach elsttyp in Ext Tot { /* begin `base' loop */
  local elstld = lower("`elsttyp'")
  foreach type in b se4 e tbl {
    mat drop `elstld'elast`usemissg'_`type'
    }
  }
mat drop intelast1_tbl
foreach type in b se4 e {
  mat rename intelast`usemissg'_`type' uncorr`usemissg'_aerrr_`type'
  }

matload intelast`usemissg'_tbl, p("$rootslct/tex/v6fs/pt$par-af$aff-$waglvl-uncorrected-cf") over missing(.) dropall
mat rename intelast`usemissg'_tbl uncorrct`usemissg'_tbl
matload intelast`usemissg'_tbl, p("$rootslct/tex/v6fs/pt$par-af$aff-$waglvl-cf") over missing(.) dropall
mat rename intelast`usemissg'_tbl corrct`usemissg'_tbl
local vecname corrct`usemissg'
mat issig = J(5,5,1)
mat colnames issig = mWageHO mWageCE mWageDE mWageOI mWageWE
mat rownames issig = rLDemHO rLDemCE rLDemDE rLDemOI rLDemWE
local lvl (100-95)/200
tokenize HOM $regagg
foreach vecname in uncorrct`usemissg' corrct`usemissg' {
  forvalues colj = 1/5 {
    forvalues rowi = 1/5 {
      local r2dg = substr("``rowi''",1,2)
      if abs(`vecname'_tbl[rownumb(`vecname'_tbl,"rLDem`r2dg'"),`colj']/`vecname'_tbl[rownumb(`vecname'_tbl,"rLDem`r2dg'")+2,`colj']) > abs(invnorm(`lvl')) & abs(`vecname'_tbl[rownumb(`vecname'_tbl,"rLDem`r2dg'"),`colj']/`vecname'_tbl[rownumb(`vecname'_tbl,"rLDem`r2dg'")+2,`colj'])~=.  matrix issig[`rowi',`colj']=issig[`rowi',`colj']*1
      else  matrix issig[`rowi',`colj']=issig[`rowi',`colj']*0
      }
    }
  }
mat issig = - (issig - J(5,5,1))*1000 + J(5,5,.00001)
mat colnames issig = mWageHO mWageCE mWageDE mWageOI mWageWE
mat rownames issig = rLDemHO rLDemCE rLDemDE rLDemOI rLDemWE
mat drop uncorr`usemissg'_aerrr_se4 corrct`usemissg'_tbl uncorrct`usemissg'_tbl
mat rename issig uncorr`usemissg'_aerrr_se3
est2tex uncorr`usemissg'_aerrr, replace dropall preserve multse(3) mark(starb 3) path(tex/v6fs/pt$par-af$aff-$waglvl-uncorr-selct2stp-cf) fancy levels(95 95 95)


cd "$root"
